import React from 'react';
import { type WidthObserverProps } from './types';
/**
 * This component will observer the current width,
 * and it will call the `setWidth` callback every time this changes.
 *
 * The only required is the parent HTMLElement should have `position: relative`
 * because this is an absolute element.
 */
export declare const WidthObserver: React.MemoExoticComponent<(props: WidthObserverProps) => React.JSX.Element>;
export default WidthObserver;
